#include <MacroPatternMatch.h>

#include "HROOTCoreTObject.h"
#include "HROOTHistTH1.h"
#include "HROOTHistTAxis.h"
#include "HROOTHistTFormula.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreTAttMarker.h"
#include "TF1.h"
#include "HROOTHistTF1.h"

using namespace std;


template<class ToType, class FromType>
const ToType* to_const(const FromType* x) {
  return reinterpret_cast<const ToType*>(x);
}

template<class ToType, class FromType>
ToType* to_nonconst(FromType* x) {
  return reinterpret_cast<ToType*>(x);
}

template<class ToType, class FromType>
const ToType& to_constref(const FromType& x) {
  return reinterpret_cast<const ToType&>(x);
}

template<class ToType, class FromType>
ToType& to_nonconstref(FromType& x) {
  return reinterpret_cast<ToType&>(x);
}


#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )


TFORMULA_DEF_VIRT(TF1)
TATTLINE_DEF_VIRT(TF1)
TATTFILL_DEF_VIRT(TF1)
TATTMARKER_DEF_VIRT(TF1)
TNAMED_DEF_VIRT(TF1)
TOBJECT_DEF_VIRT(TF1)
DELETABLE_DEF_VIRT(TF1)

TF1_DEF_VIRT(TF1)

TF1_DEF_NONVIRT(TF1)


