#include <MacroPatternMatch.h>

#include "HROOTHistTF1.h"
#include "HROOTHistTH1F.h"
#include "HROOTHistTAxis.h"
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreTAttMarker.h"
#include "TGraph.h"
#include "HROOTHistTGraph.h"

using namespace std;


template<class ToType, class FromType>
const ToType* to_const(const FromType* x) {
  return reinterpret_cast<const ToType*>(x);
}

template<class ToType, class FromType>
ToType* to_nonconst(FromType* x) {
  return reinterpret_cast<ToType*>(x);
}

template<class ToType, class FromType>
const ToType& to_constref(const FromType& x) {
  return reinterpret_cast<const ToType&>(x);
}

template<class ToType, class FromType>
ToType& to_nonconstref(FromType& x) {
  return reinterpret_cast<ToType&>(x);
}


#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )


TNAMED_DEF_VIRT(TGraph)
TATTLINE_DEF_VIRT(TGraph)
TATTFILL_DEF_VIRT(TGraph)
TATTMARKER_DEF_VIRT(TGraph)
TOBJECT_DEF_VIRT(TGraph)
DELETABLE_DEF_VIRT(TGraph)

TGRAPH_DEF_VIRT(TGraph)

TGRAPH_DEF_NONVIRT(TGraph)


