#include <MacroPatternMatch.h>

#include "HROOTHistTH1.h"
#include "HROOTCoreTArrayD.h"
#include "TH1D.h"
#include "HROOTHistTH1D.h"

using namespace std;


template<class ToType, class FromType>
const ToType* to_const(const FromType* x) {
  return reinterpret_cast<const ToType*>(x);
}

template<class ToType, class FromType>
ToType* to_nonconst(FromType* x) {
  return reinterpret_cast<ToType*>(x);
}

template<class ToType, class FromType>
const ToType& to_constref(const FromType& x) {
  return reinterpret_cast<const ToType&>(x);
}

template<class ToType, class FromType>
ToType& to_nonconstref(FromType& x) {
  return reinterpret_cast<ToType&>(x);
}


#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )


TH1_DEF_VIRT(TH1D)
TARRAYD_DEF_VIRT(TH1D)
TOBJECT_DEF_VIRT(TH1D)
TATTLINE_DEF_VIRT(TH1D)
TATTFILL_DEF_VIRT(TH1D)
TATTMARKER_DEF_VIRT(TH1D)
DELETABLE_DEF_VIRT(TH1D)
TARRAY_DEF_VIRT(TH1D)

TH1D_DEF_VIRT(TH1D)

TH1D_DEF_NONVIRT(TH1D)


