#include <MacroPatternMatch.h>

#include "HROOTHistTH1.h"
#include "HROOTCoreTArrayF.h"
#include "TH1F.h"
#include "HROOTHistTH1F.h"

using namespace std;


template<class ToType, class FromType>
const ToType* to_const(const FromType* x) {
  return reinterpret_cast<const ToType*>(x);
}

template<class ToType, class FromType>
ToType* to_nonconst(FromType* x) {
  return reinterpret_cast<ToType*>(x);
}

template<class ToType, class FromType>
const ToType& to_constref(const FromType& x) {
  return reinterpret_cast<const ToType&>(x);
}

template<class ToType, class FromType>
ToType& to_nonconstref(FromType& x) {
  return reinterpret_cast<ToType&>(x);
}


#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )


TH1_DEF_VIRT(TH1F)
TARRAYF_DEF_VIRT(TH1F)
TOBJECT_DEF_VIRT(TH1F)
TATTLINE_DEF_VIRT(TH1F)
TATTFILL_DEF_VIRT(TH1F)
TATTMARKER_DEF_VIRT(TH1F)
DELETABLE_DEF_VIRT(TH1F)
TARRAY_DEF_VIRT(TH1F)

TH1F_DEF_VIRT(TH1F)

TH1F_DEF_NONVIRT(TH1F)


