#include <MacroPatternMatch.h>

#include "HROOTHistTH1.h"
#include "HROOTCoreTArrayI.h"
#include "TH1I.h"
#include "HROOTHistTH1I.h"

using namespace std;


template<class ToType, class FromType>
const ToType* to_const(const FromType* x) {
  return reinterpret_cast<const ToType*>(x);
}

template<class ToType, class FromType>
ToType* to_nonconst(FromType* x) {
  return reinterpret_cast<ToType*>(x);
}

template<class ToType, class FromType>
const ToType& to_constref(const FromType& x) {
  return reinterpret_cast<const ToType&>(x);
}

template<class ToType, class FromType>
ToType& to_nonconstref(FromType& x) {
  return reinterpret_cast<ToType&>(x);
}


#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )


TH1_DEF_VIRT(TH1I)
TARRAYI_DEF_VIRT(TH1I)
TOBJECT_DEF_VIRT(TH1I)
TATTLINE_DEF_VIRT(TH1I)
TATTFILL_DEF_VIRT(TH1I)
TATTMARKER_DEF_VIRT(TH1I)
DELETABLE_DEF_VIRT(TH1I)
TARRAY_DEF_VIRT(TH1I)

TH1I_DEF_VIRT(TH1I)

TH1I_DEF_NONVIRT(TH1I)


