#include <MacroPatternMatch.h>

#include "HROOTHistTH2.h"
#include "HROOTCoreTArrayC.h"
#include "TH2C.h"
#include "HROOTHistTH2C.h"

using namespace std;


template<class ToType, class FromType>
const ToType* to_const(const FromType* x) {
  return reinterpret_cast<const ToType*>(x);
}

template<class ToType, class FromType>
ToType* to_nonconst(FromType* x) {
  return reinterpret_cast<ToType*>(x);
}

template<class ToType, class FromType>
const ToType& to_constref(const FromType& x) {
  return reinterpret_cast<const ToType&>(x);
}

template<class ToType, class FromType>
ToType& to_nonconstref(FromType& x) {
  return reinterpret_cast<ToType&>(x);
}


#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )

#define IS_TH2C_fill1_PROTECTED ()

TH2_DEF_VIRT(TH2C)
TARRAYC_DEF_VIRT(TH2C)
TH1_DEF_VIRT(TH2C)
TOBJECT_DEF_VIRT(TH2C)
TATTLINE_DEF_VIRT(TH2C)
TATTFILL_DEF_VIRT(TH2C)
TATTMARKER_DEF_VIRT(TH2C)
DELETABLE_DEF_VIRT(TH2C)
TARRAY_DEF_VIRT(TH2C)

TH2C_DEF_VIRT(TH2C)

TH2C_DEF_NONVIRT(TH2C)


