#include <MacroPatternMatch.h>

#include "HROOTHistTH2.h"
#include "TH2Poly.h"
#include "HROOTHistTH2Poly.h"

using namespace std;


template<class ToType, class FromType>
const ToType* to_const(const FromType* x) {
  return reinterpret_cast<const ToType*>(x);
}

template<class ToType, class FromType>
ToType* to_nonconst(FromType* x) {
  return reinterpret_cast<ToType*>(x);
}

template<class ToType, class FromType>
const ToType& to_constref(const FromType& x) {
  return reinterpret_cast<const ToType&>(x);
}

template<class ToType, class FromType>
ToType& to_nonconstref(FromType& x) {
  return reinterpret_cast<ToType&>(x);
}


#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )

#define IS_TH2Poly_fill1_PROTECTED ()

TH2_DEF_VIRT(TH2Poly)
TH1_DEF_VIRT(TH2Poly)
TOBJECT_DEF_VIRT(TH2Poly)
TATTLINE_DEF_VIRT(TH2Poly)
TATTFILL_DEF_VIRT(TH2Poly)
TATTMARKER_DEF_VIRT(TH2Poly)
DELETABLE_DEF_VIRT(TH2Poly)

TH2POLY_DEF_VIRT(TH2Poly)

TH2POLY_DEF_NONVIRT(TH2Poly)


