#include <MacroPatternMatch.h>

#include "HROOTHistTH3.h"
#include "HROOTCoreTArrayC.h"
#include "TH3C.h"
#include "HROOTHistTH3C.h"

using namespace std;


template<class ToType, class FromType>
const ToType* to_const(const FromType* x) {
  return reinterpret_cast<const ToType*>(x);
}

template<class ToType, class FromType>
ToType* to_nonconst(FromType* x) {
  return reinterpret_cast<ToType*>(x);
}

template<class ToType, class FromType>
const ToType& to_constref(const FromType& x) {
  return reinterpret_cast<const ToType&>(x);
}

template<class ToType, class FromType>
ToType& to_nonconstref(FromType& x) {
  return reinterpret_cast<ToType&>(x);
}


#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )

#define IS_TH3C_fill1_PROTECTED ()
#define IS_TH3C_fill1w_PROTECTED ()

TH3_DEF_VIRT(TH3C)
TARRAYC_DEF_VIRT(TH3C)
TH1_DEF_VIRT(TH3C)
TATT3D_DEF_VIRT(TH3C)
TOBJECT_DEF_VIRT(TH3C)
TATTLINE_DEF_VIRT(TH3C)
TATTFILL_DEF_VIRT(TH3C)
TATTMARKER_DEF_VIRT(TH3C)
DELETABLE_DEF_VIRT(TH3C)
TARRAY_DEF_VIRT(TH3C)

TH3C_DEF_VIRT(TH3C)

TH3C_DEF_NONVIRT(TH3C)


