#include <MacroPatternMatch.h>

#include "HROOTHistTH3.h"
#include "HROOTCoreTArrayD.h"
#include "TH3D.h"
#include "HROOTHistTH3D.h"

using namespace std;


template<class ToType, class FromType>
const ToType* to_const(const FromType* x) {
  return reinterpret_cast<const ToType*>(x);
}

template<class ToType, class FromType>
ToType* to_nonconst(FromType* x) {
  return reinterpret_cast<ToType*>(x);
}

template<class ToType, class FromType>
const ToType& to_constref(const FromType& x) {
  return reinterpret_cast<const ToType&>(x);
}

template<class ToType, class FromType>
ToType& to_nonconstref(FromType& x) {
  return reinterpret_cast<ToType&>(x);
}


#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )

#define IS_TH3D_fill1_PROTECTED ()
#define IS_TH3D_fill1w_PROTECTED ()

TH3_DEF_VIRT(TH3D)
TARRAYD_DEF_VIRT(TH3D)
TH1_DEF_VIRT(TH3D)
TATT3D_DEF_VIRT(TH3D)
TOBJECT_DEF_VIRT(TH3D)
TATTLINE_DEF_VIRT(TH3D)
TATTFILL_DEF_VIRT(TH3D)
TATTMARKER_DEF_VIRT(TH3D)
DELETABLE_DEF_VIRT(TH3D)
TARRAY_DEF_VIRT(TH3D)

TH3D_DEF_VIRT(TH3D)

TH3D_DEF_NONVIRT(TH3D)


