#include <MacroPatternMatch.h>

#include "HROOTHistTH3.h"
#include "HROOTCoreTArrayF.h"
#include "TH3F.h"
#include "HROOTHistTH3F.h"

using namespace std;


template<class ToType, class FromType>
const ToType* to_const(const FromType* x) {
  return reinterpret_cast<const ToType*>(x);
}

template<class ToType, class FromType>
ToType* to_nonconst(FromType* x) {
  return reinterpret_cast<ToType*>(x);
}

template<class ToType, class FromType>
const ToType& to_constref(const FromType& x) {
  return reinterpret_cast<const ToType&>(x);
}

template<class ToType, class FromType>
ToType& to_nonconstref(FromType& x) {
  return reinterpret_cast<ToType&>(x);
}


#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )

#define IS_TH3F_fill1_PROTECTED ()
#define IS_TH3F_fill1w_PROTECTED ()

TH3_DEF_VIRT(TH3F)
TARRAYF_DEF_VIRT(TH3F)
TH1_DEF_VIRT(TH3F)
TATT3D_DEF_VIRT(TH3F)
TOBJECT_DEF_VIRT(TH3F)
TATTLINE_DEF_VIRT(TH3F)
TATTFILL_DEF_VIRT(TH3F)
TATTMARKER_DEF_VIRT(TH3F)
DELETABLE_DEF_VIRT(TH3F)
TARRAY_DEF_VIRT(TH3F)

TH3F_DEF_VIRT(TH3F)

TH3F_DEF_NONVIRT(TH3F)


