{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Hist.TH1I.Implementation where


import FFICXX.Runtime.Cast

import HROOT.Hist.TH1I.RawType
import HROOT.Hist.TH1I.FFI
import HROOT.Hist.TH1I.Interface
import HROOT.Hist.TH1I.Cast
import HROOT.Core.TDirectory.RawType
import HROOT.Core.TDirectory.Cast
import HROOT.Core.TDirectory.Interface
import HROOT.Hist.TF1.RawType
import HROOT.Hist.TF1.Cast
import HROOT.Hist.TF1.Interface
import HROOT.Core.TArrayD.RawType
import HROOT.Core.TArrayD.Cast
import HROOT.Core.TArrayD.Interface
import HROOT.Hist.TAxis.RawType
import HROOT.Hist.TAxis.Cast
import HROOT.Hist.TAxis.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Hist.TH1.RawType
import HROOT.Hist.TH1.Cast
import HROOT.Hist.TH1.Interface
import HROOT.Core.TArrayI.RawType
import HROOT.Core.TArrayI.Cast
import HROOT.Core.TArrayI.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.Cast
import HROOT.Core.TAttLine.Interface
import HROOT.Core.TAttFill.RawType
import HROOT.Core.TAttFill.Cast
import HROOT.Core.TAttFill.Interface
import HROOT.Core.TAttMarker.RawType
import HROOT.Core.TAttMarker.Cast
import HROOT.Core.TAttMarker.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface
import HROOT.Core.TArray.RawType
import HROOT.Core.TArray.Cast
import HROOT.Core.TArray.Interface

import Data.Word
import Foreign.C
import Foreign.Ptr 
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITH1I TH1I where
instance ITH1 TH1I where
  add = xform2 c_th1i_add
  addBinContent = xform2 c_th1i_addbincontent
  chi2Test = xform3 c_th1i_chi2test
  computeIntegral = xform0 c_th1i_computeintegral
  directoryAutoAdd = xform1 c_th1i_directoryautoadd
  divide = xform5 c_th1i_divide
  drawCopyTH1 = xform1 c_th1i_drawcopyth1
  drawNormalized = xform2 c_th1i_drawnormalized
  drawPanelTH1 = xform0 c_th1i_drawpanelth1
  bufferEmpty = xform1 c_th1i_bufferempty
  evalF = xform2 c_th1i_evalf
  fFT = xform2 c_th1i_fft
  fill1 = xform1 c_th1i_fill1
  fill1w = xform2 c_th1i_fill1w
  fillN1 = xform4 c_th1i_filln1
  fillRandom = xform2 c_th1i_fillrandom
  findBin = xform3 c_th1i_findbin
  findFixBin = xform3 c_th1i_findfixbin
  findFirstBinAbove = xform2 c_th1i_findfirstbinabove
  findLastBinAbove = xform2 c_th1i_findlastbinabove
  fitPanelTH1 = xform0 c_th1i_fitpanelth1
  getNdivisionA = xform1 c_th1i_getndivisiona
  getAxisColorA = xform1 c_th1i_getaxiscolora
  getLabelColorA = xform1 c_th1i_getlabelcolora
  getLabelFontA = xform1 c_th1i_getlabelfonta
  getLabelOffsetA = xform1 c_th1i_getlabeloffseta
  getLabelSizeA = xform1 c_th1i_getlabelsizea
  getTitleFontA = xform1 c_th1i_gettitlefonta
  getTitleOffsetA = xform1 c_th1i_gettitleoffseta
  getTitleSizeA = xform1 c_th1i_gettitlesizea
  getTickLengthA = xform1 c_th1i_getticklengtha
  getBarOffset = xform0 c_th1i_getbaroffset
  getBarWidth = xform0 c_th1i_getbarwidth
  getContour = xform1 c_th1i_getcontour
  getContourLevel = xform1 c_th1i_getcontourlevel
  getContourLevelPad = xform1 c_th1i_getcontourlevelpad
  getBin = xform3 c_th1i_getbin
  getBinCenter = xform1 c_th1i_getbincenter
  getBinContent1 = xform1 c_th1i_getbincontent1
  getBinContent2 = xform2 c_th1i_getbincontent2
  getBinContent3 = xform3 c_th1i_getbincontent3
  getBinError1 = xform1 c_th1i_getbinerror1
  getBinError2 = xform2 c_th1i_getbinerror2
  getBinError3 = xform3 c_th1i_getbinerror3
  getBinLowEdge = xform1 c_th1i_getbinlowedge
  getBinWidth = xform1 c_th1i_getbinwidth
  getCellContent = xform2 c_th1i_getcellcontent
  getCellError = xform2 c_th1i_getcellerror
  getEntries = xform0 c_th1i_getentries
  getEffectiveEntries = xform0 c_th1i_geteffectiveentries
  getFunction = xform1 c_th1i_getfunction
  getDimension = xform0 c_th1i_getdimension
  getKurtosis = xform1 c_th1i_getkurtosis
  getLowEdge = xform1 c_th1i_getlowedge
  getMaximumTH1 = xform1 c_th1i_getmaximumth1
  getMaximumBin = xform0 c_th1i_getmaximumbin
  getMaximumStored = xform0 c_th1i_getmaximumstored
  getMinimumTH1 = xform1 c_th1i_getminimumth1
  getMinimumBin = xform0 c_th1i_getminimumbin
  getMinimumStored = xform0 c_th1i_getminimumstored
  getMean = xform1 c_th1i_getmean
  getMeanError = xform1 c_th1i_getmeanerror
  getNbinsX = xform0 c_th1i_getnbinsx
  getNbinsY = xform0 c_th1i_getnbinsy
  getNbinsZ = xform0 c_th1i_getnbinsz
  getQuantilesTH1 = xform3 c_th1i_getquantilesth1
  getRandom = xform0 c_th1i_getrandom
  getStats = xform1 c_th1i_getstats
  getSumOfWeights = xform0 c_th1i_getsumofweights
  getSumw2 = xform0 c_th1i_getsumw2
  getSumw2N = xform0 c_th1i_getsumw2n
  getRMS = xform1 c_th1i_getrms
  getRMSError = xform1 c_th1i_getrmserror
  getSkewness = xform1 c_th1i_getskewness
  integral1 = xform3 c_th1i_integral1
  interpolate1 = xform1 c_th1i_interpolate1
  interpolate2 = xform2 c_th1i_interpolate2
  interpolate3 = xform3 c_th1i_interpolate3
  kolmogorovTest = xform2 c_th1i_kolmogorovtest
  labelsDeflate = xform1 c_th1i_labelsdeflate
  labelsInflate = xform1 c_th1i_labelsinflate
  labelsOption = xform2 c_th1i_labelsoption
  multiflyF = xform2 c_th1i_multiflyf
  multiply = xform5 c_th1i_multiply
  putStats = xform1 c_th1i_putstats
  rebin = xform3 c_th1i_rebin
  rebinAxis = xform2 c_th1i_rebinaxis
  rebuild = xform1 c_th1i_rebuild
  recursiveRemove = xform1 c_th1i_recursiveremove
  reset = xform1 c_th1i_reset
  resetStats = xform0 c_th1i_resetstats
  scale = xform2 c_th1i_scale
  setAxisColorA = xform2 c_th1i_setaxiscolora
  setAxisRange = xform3 c_th1i_setaxisrange
  setBarOffset = xform1 c_th1i_setbaroffset
  setBarWidth = xform1 c_th1i_setbarwidth
  setBinContent1 = xform2 c_th1i_setbincontent1
  setBinContent2 = xform3 c_th1i_setbincontent2
  setBinContent3 = xform4 c_th1i_setbincontent3
  setBinError1 = xform2 c_th1i_setbinerror1
  setBinError2 = xform3 c_th1i_setbinerror2
  setBinError3 = xform4 c_th1i_setbinerror3
  setBins1 = xform2 c_th1i_setbins1
  setBins2 = xform4 c_th1i_setbins2
  setBins3 = xform6 c_th1i_setbins3
  setBinsLength = xform1 c_th1i_setbinslength
  setBuffer = xform2 c_th1i_setbuffer
  setCellContent = xform3 c_th1i_setcellcontent
  setContent = xform1 c_th1i_setcontent
  setContour = xform2 c_th1i_setcontour
  setContourLevel = xform2 c_th1i_setcontourlevel
  setDirectory = xform1 c_th1i_setdirectory
  setEntries = xform1 c_th1i_setentries
  setError = xform1 c_th1i_seterror
  setLabelColorA = xform2 c_th1i_setlabelcolora
  setLabelSizeA = xform2 c_th1i_setlabelsizea
  setLabelFontA = xform2 c_th1i_setlabelfonta
  setLabelOffsetA = xform2 c_th1i_setlabeloffseta
  setMaximum = xform1 c_th1i_setmaximum
  setMinimum = xform1 c_th1i_setminimum
  setNormFactor = xform1 c_th1i_setnormfactor
  setStats = xform1 c_th1i_setstats
  setOption = xform1 c_th1i_setoption
  setXTitle = xform1 c_th1i_setxtitle
  setYTitle = xform1 c_th1i_setytitle
  setZTitle = xform1 c_th1i_setztitle
  showBackground = xform2 c_th1i_showbackground
  showPeaks = xform3 c_th1i_showpeaks
  smooth = xform2 c_th1i_smooth
  sumw2 = xform0 c_th1i_sumw2
instance ITArrayI TH1I where
instance ITObject TH1I where
  draw = xform1 c_th1i_draw
  findObject = xform1 c_th1i_findobject
  getName = xform0 c_th1i_getname
  isA = xform0 c_th1i_isa
  paint = xform1 c_th1i_paint
  printObj = xform1 c_th1i_printobj
  saveAs = xform2 c_th1i_saveas
  write = xform3 c_th1i_write
instance ITAttLine TH1I where
  getLineColor = xform0 c_th1i_getlinecolor
  getLineStyle = xform0 c_th1i_getlinestyle
  getLineWidth = xform0 c_th1i_getlinewidth
  resetAttLine = xform1 c_th1i_resetattline
  setLineAttributes = xform0 c_th1i_setlineattributes
  setLineColor = xform1 c_th1i_setlinecolor
  setLineStyle = xform1 c_th1i_setlinestyle
  setLineWidth = xform1 c_th1i_setlinewidth
instance ITAttFill TH1I where
  setFillColor = xform1 c_th1i_setfillcolor
  setFillStyle = xform1 c_th1i_setfillstyle
instance ITAttMarker TH1I where
  getMarkerColor = xform0 c_th1i_getmarkercolor
  getMarkerStyle = xform0 c_th1i_getmarkerstyle
  getMarkerSize = xform0 c_th1i_getmarkersize
  resetAttMarker = xform1 c_th1i_resetattmarker
  setMarkerAttributes = xform0 c_th1i_setmarkerattributes
  setMarkerColor = xform1 c_th1i_setmarkercolor
  setMarkerStyle = xform1 c_th1i_setmarkerstyle
  setMarkerSize = xform1 c_th1i_setmarkersize
instance IDeletable TH1I where
  delete = xform0 c_th1i_delete
instance ITArray TH1I where

instance ITH1I (Exist TH1I) where

instance ITH1 (Exist TH1I) where
  add (ETH1I x) = add x
  addBinContent (ETH1I x) = addBinContent x
  chi2Test (ETH1I x) = chi2Test x
  computeIntegral (ETH1I x) = computeIntegral x
  directoryAutoAdd (ETH1I x) = directoryAutoAdd x
  divide (ETH1I x) = divide x
  drawCopyTH1 (ETH1I x) a1 = return . ETH1I =<< drawCopyTH1 x a1
  drawNormalized (ETH1I x) = drawNormalized x
  drawPanelTH1 (ETH1I x) = drawPanelTH1 x
  bufferEmpty (ETH1I x) = bufferEmpty x
  evalF (ETH1I x) = evalF x
  fFT (ETH1I x) = fFT x
  fill1 (ETH1I x) = fill1 x
  fill1w (ETH1I x) = fill1w x
  fillN1 (ETH1I x) = fillN1 x
  fillRandom (ETH1I x) = fillRandom x
  findBin (ETH1I x) = findBin x
  findFixBin (ETH1I x) = findFixBin x
  findFirstBinAbove (ETH1I x) = findFirstBinAbove x
  findLastBinAbove (ETH1I x) = findLastBinAbove x
  fitPanelTH1 (ETH1I x) = fitPanelTH1 x
  getNdivisionA (ETH1I x) = getNdivisionA x
  getAxisColorA (ETH1I x) = getAxisColorA x
  getLabelColorA (ETH1I x) = getLabelColorA x
  getLabelFontA (ETH1I x) = getLabelFontA x
  getLabelOffsetA (ETH1I x) = getLabelOffsetA x
  getLabelSizeA (ETH1I x) = getLabelSizeA x
  getTitleFontA (ETH1I x) = getTitleFontA x
  getTitleOffsetA (ETH1I x) = getTitleOffsetA x
  getTitleSizeA (ETH1I x) = getTitleSizeA x
  getTickLengthA (ETH1I x) = getTickLengthA x
  getBarOffset (ETH1I x) = getBarOffset x
  getBarWidth (ETH1I x) = getBarWidth x
  getContour (ETH1I x) = getContour x
  getContourLevel (ETH1I x) = getContourLevel x
  getContourLevelPad (ETH1I x) = getContourLevelPad x
  getBin (ETH1I x) = getBin x
  getBinCenter (ETH1I x) = getBinCenter x
  getBinContent1 (ETH1I x) = getBinContent1 x
  getBinContent2 (ETH1I x) = getBinContent2 x
  getBinContent3 (ETH1I x) = getBinContent3 x
  getBinError1 (ETH1I x) = getBinError1 x
  getBinError2 (ETH1I x) = getBinError2 x
  getBinError3 (ETH1I x) = getBinError3 x
  getBinLowEdge (ETH1I x) = getBinLowEdge x
  getBinWidth (ETH1I x) = getBinWidth x
  getCellContent (ETH1I x) = getCellContent x
  getCellError (ETH1I x) = getCellError x
  getEntries (ETH1I x) = getEntries x
  getEffectiveEntries (ETH1I x) = getEffectiveEntries x
  getFunction (ETH1I x) = getFunction x
  getDimension (ETH1I x) = getDimension x
  getKurtosis (ETH1I x) = getKurtosis x
  getLowEdge (ETH1I x) = getLowEdge x
  getMaximumTH1 (ETH1I x) = getMaximumTH1 x
  getMaximumBin (ETH1I x) = getMaximumBin x
  getMaximumStored (ETH1I x) = getMaximumStored x
  getMinimumTH1 (ETH1I x) = getMinimumTH1 x
  getMinimumBin (ETH1I x) = getMinimumBin x
  getMinimumStored (ETH1I x) = getMinimumStored x
  getMean (ETH1I x) = getMean x
  getMeanError (ETH1I x) = getMeanError x
  getNbinsX (ETH1I x) = getNbinsX x
  getNbinsY (ETH1I x) = getNbinsY x
  getNbinsZ (ETH1I x) = getNbinsZ x
  getQuantilesTH1 (ETH1I x) = getQuantilesTH1 x
  getRandom (ETH1I x) = getRandom x
  getStats (ETH1I x) = getStats x
  getSumOfWeights (ETH1I x) = getSumOfWeights x
  getSumw2 (ETH1I x) = getSumw2 x
  getSumw2N (ETH1I x) = getSumw2N x
  getRMS (ETH1I x) = getRMS x
  getRMSError (ETH1I x) = getRMSError x
  getSkewness (ETH1I x) = getSkewness x
  integral1 (ETH1I x) = integral1 x
  interpolate1 (ETH1I x) = interpolate1 x
  interpolate2 (ETH1I x) = interpolate2 x
  interpolate3 (ETH1I x) = interpolate3 x
  kolmogorovTest (ETH1I x) = kolmogorovTest x
  labelsDeflate (ETH1I x) = labelsDeflate x
  labelsInflate (ETH1I x) = labelsInflate x
  labelsOption (ETH1I x) = labelsOption x
  multiflyF (ETH1I x) = multiflyF x
  multiply (ETH1I x) = multiply x
  putStats (ETH1I x) = putStats x
  rebin (ETH1I x) = rebin x
  rebinAxis (ETH1I x) = rebinAxis x
  rebuild (ETH1I x) = rebuild x
  recursiveRemove (ETH1I x) = recursiveRemove x
  reset (ETH1I x) = reset x
  resetStats (ETH1I x) = resetStats x
  scale (ETH1I x) = scale x
  setAxisColorA (ETH1I x) = setAxisColorA x
  setAxisRange (ETH1I x) = setAxisRange x
  setBarOffset (ETH1I x) = setBarOffset x
  setBarWidth (ETH1I x) = setBarWidth x
  setBinContent1 (ETH1I x) = setBinContent1 x
  setBinContent2 (ETH1I x) = setBinContent2 x
  setBinContent3 (ETH1I x) = setBinContent3 x
  setBinError1 (ETH1I x) = setBinError1 x
  setBinError2 (ETH1I x) = setBinError2 x
  setBinError3 (ETH1I x) = setBinError3 x
  setBins1 (ETH1I x) = setBins1 x
  setBins2 (ETH1I x) = setBins2 x
  setBins3 (ETH1I x) = setBins3 x
  setBinsLength (ETH1I x) = setBinsLength x
  setBuffer (ETH1I x) = setBuffer x
  setCellContent (ETH1I x) = setCellContent x
  setContent (ETH1I x) = setContent x
  setContour (ETH1I x) = setContour x
  setContourLevel (ETH1I x) = setContourLevel x
  setDirectory (ETH1I x) = setDirectory x
  setEntries (ETH1I x) = setEntries x
  setError (ETH1I x) = setError x
  setLabelColorA (ETH1I x) = setLabelColorA x
  setLabelSizeA (ETH1I x) = setLabelSizeA x
  setLabelFontA (ETH1I x) = setLabelFontA x
  setLabelOffsetA (ETH1I x) = setLabelOffsetA x
  setMaximum (ETH1I x) = setMaximum x
  setMinimum (ETH1I x) = setMinimum x
  setNormFactor (ETH1I x) = setNormFactor x
  setStats (ETH1I x) = setStats x
  setOption (ETH1I x) = setOption x
  setXTitle (ETH1I x) = setXTitle x
  setYTitle (ETH1I x) = setYTitle x
  setZTitle (ETH1I x) = setZTitle x
  showBackground (ETH1I x) = showBackground x
  showPeaks (ETH1I x) = showPeaks x
  smooth (ETH1I x) = smooth x
  sumw2 (ETH1I x) = sumw2 x
instance ITArrayI (Exist TH1I) where

instance ITObject (Exist TH1I) where
  draw (ETH1I x) = draw x
  findObject (ETH1I x) = findObject x
  getName (ETH1I x) = getName x
  isA (ETH1I x) = isA x
  paint (ETH1I x) = paint x
  printObj (ETH1I x) = printObj x
  saveAs (ETH1I x) = saveAs x
  write (ETH1I x) = write x
instance ITAttLine (Exist TH1I) where
  getLineColor (ETH1I x) = getLineColor x
  getLineStyle (ETH1I x) = getLineStyle x
  getLineWidth (ETH1I x) = getLineWidth x
  resetAttLine (ETH1I x) = resetAttLine x
  setLineAttributes (ETH1I x) = setLineAttributes x
  setLineColor (ETH1I x) = setLineColor x
  setLineStyle (ETH1I x) = setLineStyle x
  setLineWidth (ETH1I x) = setLineWidth x
instance ITAttFill (Exist TH1I) where
  setFillColor (ETH1I x) = setFillColor x
  setFillStyle (ETH1I x) = setFillStyle x
instance ITAttMarker (Exist TH1I) where
  getMarkerColor (ETH1I x) = getMarkerColor x
  getMarkerStyle (ETH1I x) = getMarkerStyle x
  getMarkerSize (ETH1I x) = getMarkerSize x
  resetAttMarker (ETH1I x) = resetAttMarker x
  setMarkerAttributes (ETH1I x) = setMarkerAttributes x
  setMarkerColor (ETH1I x) = setMarkerColor x
  setMarkerStyle (ETH1I x) = setMarkerStyle x
  setMarkerSize (ETH1I x) = setMarkerSize x
instance IDeletable (Exist TH1I) where
  delete (ETH1I x) = delete x
instance ITArray (Exist TH1I) where








instance FPtr (Exist TH1I) where
  type Raw (Exist TH1I) = RawTH1I
  get_fptr (ETH1I obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETH1I (cast_fptr_to_obj (fptr :: ForeignPtr RawTH1I) :: TH1I)
