{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Hist.TH2C.Implementation where


import FFICXX.Runtime.Cast

import HROOT.Hist.TH2C.RawType
import HROOT.Hist.TH2C.FFI
import HROOT.Hist.TH2C.Interface
import HROOT.Hist.TH2C.Cast
import HROOT.Hist.TH1D.RawType
import HROOT.Hist.TH1D.Cast
import HROOT.Hist.TH1D.Interface
import HROOT.Hist.TF1.RawType
import HROOT.Hist.TF1.Cast
import HROOT.Hist.TF1.Interface
import HROOT.Core.TObjArray.RawType
import HROOT.Core.TObjArray.Cast
import HROOT.Core.TObjArray.Interface
import HROOT.Core.TDirectory.RawType
import HROOT.Core.TDirectory.Cast
import HROOT.Core.TDirectory.Interface
import HROOT.Core.TArrayD.RawType
import HROOT.Core.TArrayD.Cast
import HROOT.Core.TArrayD.Interface
import HROOT.Hist.TAxis.RawType
import HROOT.Hist.TAxis.Cast
import HROOT.Hist.TAxis.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Hist.TH2.RawType
import HROOT.Hist.TH2.Cast
import HROOT.Hist.TH2.Interface
import HROOT.Core.TArrayC.RawType
import HROOT.Core.TArrayC.Cast
import HROOT.Core.TArrayC.Interface
import HROOT.Hist.TH1.RawType
import HROOT.Hist.TH1.Cast
import HROOT.Hist.TH1.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.Cast
import HROOT.Core.TAttLine.Interface
import HROOT.Core.TAttFill.RawType
import HROOT.Core.TAttFill.Cast
import HROOT.Core.TAttFill.Interface
import HROOT.Core.TAttMarker.RawType
import HROOT.Core.TAttMarker.Cast
import HROOT.Core.TAttMarker.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface
import HROOT.Core.TArray.RawType
import HROOT.Core.TArray.Cast
import HROOT.Core.TArray.Interface

import Data.Word
import Foreign.C
import Foreign.Ptr 
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITH2C TH2C where
instance ITH2 TH2C where
  fill2 = xform2 c_th2c_fill2
  fill2w = xform3 c_th2c_fill2w
  fillN2 = xform5 c_th2c_filln2
  fillRandom2 = xform2 c_th2c_fillrandom2
  findFirstBinAbove2 = xform2 c_th2c_findfirstbinabove2
  findLastBinAbove2 = xform2 c_th2c_findlastbinabove2
  fitSlicesX = xform6 c_th2c_fitslicesx
  fitSlicesY = xform6 c_th2c_fitslicesy
  getCorrelationFactor2 = xform2 c_th2c_getcorrelationfactor2
  getCovariance2 = xform2 c_th2c_getcovariance2
  integral2 = xform5 c_th2c_integral2
  rebinX2 = xform2 c_th2c_rebinx2
  rebinY2 = xform2 c_th2c_rebiny2
  rebin2D = xform3 c_th2c_rebin2d
  setShowProjectionX = xform1 c_th2c_setshowprojectionx
  setShowProjectionY = xform1 c_th2c_setshowprojectiony
instance ITArrayC TH2C where
instance ITH1 TH2C where
  add = xform2 c_th2c_add
  addBinContent = xform2 c_th2c_addbincontent
  chi2Test = xform3 c_th2c_chi2test
  computeIntegral = xform0 c_th2c_computeintegral
  directoryAutoAdd = xform1 c_th2c_directoryautoadd
  divide = xform5 c_th2c_divide
  drawCopyTH1 = xform1 c_th2c_drawcopyth1
  drawNormalized = xform2 c_th2c_drawnormalized
  drawPanelTH1 = xform0 c_th2c_drawpanelth1
  bufferEmpty = xform1 c_th2c_bufferempty
  evalF = xform2 c_th2c_evalf
  fFT = xform2 c_th2c_fft
  fill1 = xform1 c_th2c_fill1
  fill1w = xform2 c_th2c_fill1w
  fillN1 = xform4 c_th2c_filln1
  fillRandom = xform2 c_th2c_fillrandom
  findBin = xform3 c_th2c_findbin
  findFixBin = xform3 c_th2c_findfixbin
  findFirstBinAbove = xform2 c_th2c_findfirstbinabove
  findLastBinAbove = xform2 c_th2c_findlastbinabove
  fitPanelTH1 = xform0 c_th2c_fitpanelth1
  getNdivisionA = xform1 c_th2c_getndivisiona
  getAxisColorA = xform1 c_th2c_getaxiscolora
  getLabelColorA = xform1 c_th2c_getlabelcolora
  getLabelFontA = xform1 c_th2c_getlabelfonta
  getLabelOffsetA = xform1 c_th2c_getlabeloffseta
  getLabelSizeA = xform1 c_th2c_getlabelsizea
  getTitleFontA = xform1 c_th2c_gettitlefonta
  getTitleOffsetA = xform1 c_th2c_gettitleoffseta
  getTitleSizeA = xform1 c_th2c_gettitlesizea
  getTickLengthA = xform1 c_th2c_getticklengtha
  getBarOffset = xform0 c_th2c_getbaroffset
  getBarWidth = xform0 c_th2c_getbarwidth
  getContour = xform1 c_th2c_getcontour
  getContourLevel = xform1 c_th2c_getcontourlevel
  getContourLevelPad = xform1 c_th2c_getcontourlevelpad
  getBin = xform3 c_th2c_getbin
  getBinCenter = xform1 c_th2c_getbincenter
  getBinContent1 = xform1 c_th2c_getbincontent1
  getBinContent2 = xform2 c_th2c_getbincontent2
  getBinContent3 = xform3 c_th2c_getbincontent3
  getBinError1 = xform1 c_th2c_getbinerror1
  getBinError2 = xform2 c_th2c_getbinerror2
  getBinError3 = xform3 c_th2c_getbinerror3
  getBinLowEdge = xform1 c_th2c_getbinlowedge
  getBinWidth = xform1 c_th2c_getbinwidth
  getCellContent = xform2 c_th2c_getcellcontent
  getCellError = xform2 c_th2c_getcellerror
  getEntries = xform0 c_th2c_getentries
  getEffectiveEntries = xform0 c_th2c_geteffectiveentries
  getFunction = xform1 c_th2c_getfunction
  getDimension = xform0 c_th2c_getdimension
  getKurtosis = xform1 c_th2c_getkurtosis
  getLowEdge = xform1 c_th2c_getlowedge
  getMaximumTH1 = xform1 c_th2c_getmaximumth1
  getMaximumBin = xform0 c_th2c_getmaximumbin
  getMaximumStored = xform0 c_th2c_getmaximumstored
  getMinimumTH1 = xform1 c_th2c_getminimumth1
  getMinimumBin = xform0 c_th2c_getminimumbin
  getMinimumStored = xform0 c_th2c_getminimumstored
  getMean = xform1 c_th2c_getmean
  getMeanError = xform1 c_th2c_getmeanerror
  getNbinsX = xform0 c_th2c_getnbinsx
  getNbinsY = xform0 c_th2c_getnbinsy
  getNbinsZ = xform0 c_th2c_getnbinsz
  getQuantilesTH1 = xform3 c_th2c_getquantilesth1
  getRandom = xform0 c_th2c_getrandom
  getStats = xform1 c_th2c_getstats
  getSumOfWeights = xform0 c_th2c_getsumofweights
  getSumw2 = xform0 c_th2c_getsumw2
  getSumw2N = xform0 c_th2c_getsumw2n
  getRMS = xform1 c_th2c_getrms
  getRMSError = xform1 c_th2c_getrmserror
  getSkewness = xform1 c_th2c_getskewness
  integral1 = xform3 c_th2c_integral1
  interpolate1 = xform1 c_th2c_interpolate1
  interpolate2 = xform2 c_th2c_interpolate2
  interpolate3 = xform3 c_th2c_interpolate3
  kolmogorovTest = xform2 c_th2c_kolmogorovtest
  labelsDeflate = xform1 c_th2c_labelsdeflate
  labelsInflate = xform1 c_th2c_labelsinflate
  labelsOption = xform2 c_th2c_labelsoption
  multiflyF = xform2 c_th2c_multiflyf
  multiply = xform5 c_th2c_multiply
  putStats = xform1 c_th2c_putstats
  rebin = xform3 c_th2c_rebin
  rebinAxis = xform2 c_th2c_rebinaxis
  rebuild = xform1 c_th2c_rebuild
  recursiveRemove = xform1 c_th2c_recursiveremove
  reset = xform1 c_th2c_reset
  resetStats = xform0 c_th2c_resetstats
  scale = xform2 c_th2c_scale
  setAxisColorA = xform2 c_th2c_setaxiscolora
  setAxisRange = xform3 c_th2c_setaxisrange
  setBarOffset = xform1 c_th2c_setbaroffset
  setBarWidth = xform1 c_th2c_setbarwidth
  setBinContent1 = xform2 c_th2c_setbincontent1
  setBinContent2 = xform3 c_th2c_setbincontent2
  setBinContent3 = xform4 c_th2c_setbincontent3
  setBinError1 = xform2 c_th2c_setbinerror1
  setBinError2 = xform3 c_th2c_setbinerror2
  setBinError3 = xform4 c_th2c_setbinerror3
  setBins1 = xform2 c_th2c_setbins1
  setBins2 = xform4 c_th2c_setbins2
  setBins3 = xform6 c_th2c_setbins3
  setBinsLength = xform1 c_th2c_setbinslength
  setBuffer = xform2 c_th2c_setbuffer
  setCellContent = xform3 c_th2c_setcellcontent
  setContent = xform1 c_th2c_setcontent
  setContour = xform2 c_th2c_setcontour
  setContourLevel = xform2 c_th2c_setcontourlevel
  setDirectory = xform1 c_th2c_setdirectory
  setEntries = xform1 c_th2c_setentries
  setError = xform1 c_th2c_seterror
  setLabelColorA = xform2 c_th2c_setlabelcolora
  setLabelSizeA = xform2 c_th2c_setlabelsizea
  setLabelFontA = xform2 c_th2c_setlabelfonta
  setLabelOffsetA = xform2 c_th2c_setlabeloffseta
  setMaximum = xform1 c_th2c_setmaximum
  setMinimum = xform1 c_th2c_setminimum
  setNormFactor = xform1 c_th2c_setnormfactor
  setStats = xform1 c_th2c_setstats
  setOption = xform1 c_th2c_setoption
  setXTitle = xform1 c_th2c_setxtitle
  setYTitle = xform1 c_th2c_setytitle
  setZTitle = xform1 c_th2c_setztitle
  showBackground = xform2 c_th2c_showbackground
  showPeaks = xform3 c_th2c_showpeaks
  smooth = xform2 c_th2c_smooth
  sumw2 = xform0 c_th2c_sumw2
instance ITObject TH2C where
  draw = xform1 c_th2c_draw
  findObject = xform1 c_th2c_findobject
  getName = xform0 c_th2c_getname
  isA = xform0 c_th2c_isa
  paint = xform1 c_th2c_paint
  printObj = xform1 c_th2c_printobj
  saveAs = xform2 c_th2c_saveas
  write = xform3 c_th2c_write
instance ITAttLine TH2C where
  getLineColor = xform0 c_th2c_getlinecolor
  getLineStyle = xform0 c_th2c_getlinestyle
  getLineWidth = xform0 c_th2c_getlinewidth
  resetAttLine = xform1 c_th2c_resetattline
  setLineAttributes = xform0 c_th2c_setlineattributes
  setLineColor = xform1 c_th2c_setlinecolor
  setLineStyle = xform1 c_th2c_setlinestyle
  setLineWidth = xform1 c_th2c_setlinewidth
instance ITAttFill TH2C where
  setFillColor = xform1 c_th2c_setfillcolor
  setFillStyle = xform1 c_th2c_setfillstyle
instance ITAttMarker TH2C where
  getMarkerColor = xform0 c_th2c_getmarkercolor
  getMarkerStyle = xform0 c_th2c_getmarkerstyle
  getMarkerSize = xform0 c_th2c_getmarkersize
  resetAttMarker = xform1 c_th2c_resetattmarker
  setMarkerAttributes = xform0 c_th2c_setmarkerattributes
  setMarkerColor = xform1 c_th2c_setmarkercolor
  setMarkerStyle = xform1 c_th2c_setmarkerstyle
  setMarkerSize = xform1 c_th2c_setmarkersize
instance IDeletable TH2C where
  delete = xform0 c_th2c_delete
instance ITArray TH2C where

instance ITH2C (Exist TH2C) where

instance ITH2 (Exist TH2C) where
  fill2 (ETH2C x) = fill2 x
  fill2w (ETH2C x) = fill2w x
  fillN2 (ETH2C x) = fillN2 x
  fillRandom2 (ETH2C x) = fillRandom2 x
  findFirstBinAbove2 (ETH2C x) = findFirstBinAbove2 x
  findLastBinAbove2 (ETH2C x) = findLastBinAbove2 x
  fitSlicesX (ETH2C x) = fitSlicesX x
  fitSlicesY (ETH2C x) = fitSlicesY x
  getCorrelationFactor2 (ETH2C x) = getCorrelationFactor2 x
  getCovariance2 (ETH2C x) = getCovariance2 x
  integral2 (ETH2C x) = integral2 x
  rebinX2 (ETH2C x) = rebinX2 x
  rebinY2 (ETH2C x) = rebinY2 x
  rebin2D (ETH2C x) = rebin2D x
  setShowProjectionX (ETH2C x) = setShowProjectionX x
  setShowProjectionY (ETH2C x) = setShowProjectionY x
instance ITArrayC (Exist TH2C) where

instance ITH1 (Exist TH2C) where
  add (ETH2C x) = add x
  addBinContent (ETH2C x) = addBinContent x
  chi2Test (ETH2C x) = chi2Test x
  computeIntegral (ETH2C x) = computeIntegral x
  directoryAutoAdd (ETH2C x) = directoryAutoAdd x
  divide (ETH2C x) = divide x
  drawCopyTH1 (ETH2C x) a1 = return . ETH2C =<< drawCopyTH1 x a1
  drawNormalized (ETH2C x) = drawNormalized x
  drawPanelTH1 (ETH2C x) = drawPanelTH1 x
  bufferEmpty (ETH2C x) = bufferEmpty x
  evalF (ETH2C x) = evalF x
  fFT (ETH2C x) = fFT x
  fill1 (ETH2C x) = fill1 x
  fill1w (ETH2C x) = fill1w x
  fillN1 (ETH2C x) = fillN1 x
  fillRandom (ETH2C x) = fillRandom x
  findBin (ETH2C x) = findBin x
  findFixBin (ETH2C x) = findFixBin x
  findFirstBinAbove (ETH2C x) = findFirstBinAbove x
  findLastBinAbove (ETH2C x) = findLastBinAbove x
  fitPanelTH1 (ETH2C x) = fitPanelTH1 x
  getNdivisionA (ETH2C x) = getNdivisionA x
  getAxisColorA (ETH2C x) = getAxisColorA x
  getLabelColorA (ETH2C x) = getLabelColorA x
  getLabelFontA (ETH2C x) = getLabelFontA x
  getLabelOffsetA (ETH2C x) = getLabelOffsetA x
  getLabelSizeA (ETH2C x) = getLabelSizeA x
  getTitleFontA (ETH2C x) = getTitleFontA x
  getTitleOffsetA (ETH2C x) = getTitleOffsetA x
  getTitleSizeA (ETH2C x) = getTitleSizeA x
  getTickLengthA (ETH2C x) = getTickLengthA x
  getBarOffset (ETH2C x) = getBarOffset x
  getBarWidth (ETH2C x) = getBarWidth x
  getContour (ETH2C x) = getContour x
  getContourLevel (ETH2C x) = getContourLevel x
  getContourLevelPad (ETH2C x) = getContourLevelPad x
  getBin (ETH2C x) = getBin x
  getBinCenter (ETH2C x) = getBinCenter x
  getBinContent1 (ETH2C x) = getBinContent1 x
  getBinContent2 (ETH2C x) = getBinContent2 x
  getBinContent3 (ETH2C x) = getBinContent3 x
  getBinError1 (ETH2C x) = getBinError1 x
  getBinError2 (ETH2C x) = getBinError2 x
  getBinError3 (ETH2C x) = getBinError3 x
  getBinLowEdge (ETH2C x) = getBinLowEdge x
  getBinWidth (ETH2C x) = getBinWidth x
  getCellContent (ETH2C x) = getCellContent x
  getCellError (ETH2C x) = getCellError x
  getEntries (ETH2C x) = getEntries x
  getEffectiveEntries (ETH2C x) = getEffectiveEntries x
  getFunction (ETH2C x) = getFunction x
  getDimension (ETH2C x) = getDimension x
  getKurtosis (ETH2C x) = getKurtosis x
  getLowEdge (ETH2C x) = getLowEdge x
  getMaximumTH1 (ETH2C x) = getMaximumTH1 x
  getMaximumBin (ETH2C x) = getMaximumBin x
  getMaximumStored (ETH2C x) = getMaximumStored x
  getMinimumTH1 (ETH2C x) = getMinimumTH1 x
  getMinimumBin (ETH2C x) = getMinimumBin x
  getMinimumStored (ETH2C x) = getMinimumStored x
  getMean (ETH2C x) = getMean x
  getMeanError (ETH2C x) = getMeanError x
  getNbinsX (ETH2C x) = getNbinsX x
  getNbinsY (ETH2C x) = getNbinsY x
  getNbinsZ (ETH2C x) = getNbinsZ x
  getQuantilesTH1 (ETH2C x) = getQuantilesTH1 x
  getRandom (ETH2C x) = getRandom x
  getStats (ETH2C x) = getStats x
  getSumOfWeights (ETH2C x) = getSumOfWeights x
  getSumw2 (ETH2C x) = getSumw2 x
  getSumw2N (ETH2C x) = getSumw2N x
  getRMS (ETH2C x) = getRMS x
  getRMSError (ETH2C x) = getRMSError x
  getSkewness (ETH2C x) = getSkewness x
  integral1 (ETH2C x) = integral1 x
  interpolate1 (ETH2C x) = interpolate1 x
  interpolate2 (ETH2C x) = interpolate2 x
  interpolate3 (ETH2C x) = interpolate3 x
  kolmogorovTest (ETH2C x) = kolmogorovTest x
  labelsDeflate (ETH2C x) = labelsDeflate x
  labelsInflate (ETH2C x) = labelsInflate x
  labelsOption (ETH2C x) = labelsOption x
  multiflyF (ETH2C x) = multiflyF x
  multiply (ETH2C x) = multiply x
  putStats (ETH2C x) = putStats x
  rebin (ETH2C x) = rebin x
  rebinAxis (ETH2C x) = rebinAxis x
  rebuild (ETH2C x) = rebuild x
  recursiveRemove (ETH2C x) = recursiveRemove x
  reset (ETH2C x) = reset x
  resetStats (ETH2C x) = resetStats x
  scale (ETH2C x) = scale x
  setAxisColorA (ETH2C x) = setAxisColorA x
  setAxisRange (ETH2C x) = setAxisRange x
  setBarOffset (ETH2C x) = setBarOffset x
  setBarWidth (ETH2C x) = setBarWidth x
  setBinContent1 (ETH2C x) = setBinContent1 x
  setBinContent2 (ETH2C x) = setBinContent2 x
  setBinContent3 (ETH2C x) = setBinContent3 x
  setBinError1 (ETH2C x) = setBinError1 x
  setBinError2 (ETH2C x) = setBinError2 x
  setBinError3 (ETH2C x) = setBinError3 x
  setBins1 (ETH2C x) = setBins1 x
  setBins2 (ETH2C x) = setBins2 x
  setBins3 (ETH2C x) = setBins3 x
  setBinsLength (ETH2C x) = setBinsLength x
  setBuffer (ETH2C x) = setBuffer x
  setCellContent (ETH2C x) = setCellContent x
  setContent (ETH2C x) = setContent x
  setContour (ETH2C x) = setContour x
  setContourLevel (ETH2C x) = setContourLevel x
  setDirectory (ETH2C x) = setDirectory x
  setEntries (ETH2C x) = setEntries x
  setError (ETH2C x) = setError x
  setLabelColorA (ETH2C x) = setLabelColorA x
  setLabelSizeA (ETH2C x) = setLabelSizeA x
  setLabelFontA (ETH2C x) = setLabelFontA x
  setLabelOffsetA (ETH2C x) = setLabelOffsetA x
  setMaximum (ETH2C x) = setMaximum x
  setMinimum (ETH2C x) = setMinimum x
  setNormFactor (ETH2C x) = setNormFactor x
  setStats (ETH2C x) = setStats x
  setOption (ETH2C x) = setOption x
  setXTitle (ETH2C x) = setXTitle x
  setYTitle (ETH2C x) = setYTitle x
  setZTitle (ETH2C x) = setZTitle x
  showBackground (ETH2C x) = showBackground x
  showPeaks (ETH2C x) = showPeaks x
  smooth (ETH2C x) = smooth x
  sumw2 (ETH2C x) = sumw2 x
instance ITObject (Exist TH2C) where
  draw (ETH2C x) = draw x
  findObject (ETH2C x) = findObject x
  getName (ETH2C x) = getName x
  isA (ETH2C x) = isA x
  paint (ETH2C x) = paint x
  printObj (ETH2C x) = printObj x
  saveAs (ETH2C x) = saveAs x
  write (ETH2C x) = write x
instance ITAttLine (Exist TH2C) where
  getLineColor (ETH2C x) = getLineColor x
  getLineStyle (ETH2C x) = getLineStyle x
  getLineWidth (ETH2C x) = getLineWidth x
  resetAttLine (ETH2C x) = resetAttLine x
  setLineAttributes (ETH2C x) = setLineAttributes x
  setLineColor (ETH2C x) = setLineColor x
  setLineStyle (ETH2C x) = setLineStyle x
  setLineWidth (ETH2C x) = setLineWidth x
instance ITAttFill (Exist TH2C) where
  setFillColor (ETH2C x) = setFillColor x
  setFillStyle (ETH2C x) = setFillStyle x
instance ITAttMarker (Exist TH2C) where
  getMarkerColor (ETH2C x) = getMarkerColor x
  getMarkerStyle (ETH2C x) = getMarkerStyle x
  getMarkerSize (ETH2C x) = getMarkerSize x
  resetAttMarker (ETH2C x) = resetAttMarker x
  setMarkerAttributes (ETH2C x) = setMarkerAttributes x
  setMarkerColor (ETH2C x) = setMarkerColor x
  setMarkerStyle (ETH2C x) = setMarkerStyle x
  setMarkerSize (ETH2C x) = setMarkerSize x
instance IDeletable (Exist TH2C) where
  delete (ETH2C x) = delete x
instance ITArray (Exist TH2C) where








instance FPtr (Exist TH2C) where
  type Raw (Exist TH2C) = RawTH2C
  get_fptr (ETH2C obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETH2C (cast_fptr_to_obj (fptr :: ForeignPtr RawTH2C) :: TH2C)
