{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Hist.TH2D.Interface where


import Data.Word
import Foreign.C
import Foreign.Ptr
import Foreign.ForeignPtr
import FFICXX.Runtime.Cast

import HROOT.Hist.TH2D.RawType

import HROOT.Hist.TH2.Interface
import HROOT.Core.TArrayD.Interface
---- ============ ----



class (ITH2 a,ITArrayD a) => ITH2D a where

instance Existable TH2D where
  data Exist TH2D = forall a. (FPtr a, ITH2D a) => ETH2D a

upcastTH2D :: (FPtr a, ITH2D a) => a -> TH2D
upcastTH2D h = let fh = get_fptr h
                   fh2 :: ForeignPtr RawTH2D = castForeignPtr fh
               in cast_fptr_to_obj fh2

downcastTH2D :: (FPtr a, ITH2D a) => TH2D -> a 
downcastTH2D h = let fh = get_fptr h
                     fh2 = castForeignPtr fh
                 in cast_fptr_to_obj fh2
