{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Hist.TH3D.Interface where


import Data.Word
import Foreign.C
import Foreign.Ptr
import Foreign.ForeignPtr
import FFICXX.Runtime.Cast

import HROOT.Hist.TH3D.RawType

import HROOT.Hist.TH3.Interface
import HROOT.Core.TArrayD.Interface
---- ============ ----



class (ITH3 a,ITArrayD a) => ITH3D a where

instance Existable TH3D where
  data Exist TH3D = forall a. (FPtr a, ITH3D a) => ETH3D a

upcastTH3D :: (FPtr a, ITH3D a) => a -> TH3D
upcastTH3D h = let fh = get_fptr h
                   fh2 :: ForeignPtr RawTH3D = castForeignPtr fh
               in cast_fptr_to_obj fh2

downcastTH3D :: (FPtr a, ITH3D a) => TH3D -> a 
downcastTH3D h = let fh = get_fptr h
                     fh2 = castForeignPtr fh
                 in cast_fptr_to_obj fh2
