{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Hist.TH3F.Implementation where


import FFICXX.Runtime.Cast

import HROOT.Hist.TH3F.RawType
import HROOT.Hist.TH3F.FFI
import HROOT.Hist.TH3F.Interface
import HROOT.Hist.TH3F.Cast
import HROOT.Hist.TH1D.RawType
import HROOT.Hist.TH1D.Cast
import HROOT.Hist.TH1D.Interface
import HROOT.Hist.TF1.RawType
import HROOT.Hist.TF1.Cast
import HROOT.Hist.TF1.Interface
import HROOT.Core.TDirectory.RawType
import HROOT.Core.TDirectory.Cast
import HROOT.Core.TDirectory.Interface
import HROOT.Core.TArrayD.RawType
import HROOT.Core.TArrayD.Cast
import HROOT.Core.TArrayD.Interface
import HROOT.Hist.TAxis.RawType
import HROOT.Hist.TAxis.Cast
import HROOT.Hist.TAxis.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Hist.TH3.RawType
import HROOT.Hist.TH3.Cast
import HROOT.Hist.TH3.Interface
import HROOT.Core.TArrayF.RawType
import HROOT.Core.TArrayF.Cast
import HROOT.Core.TArrayF.Interface
import HROOT.Hist.TH1.RawType
import HROOT.Hist.TH1.Cast
import HROOT.Hist.TH1.Interface
import HROOT.Core.TAtt3D.RawType
import HROOT.Core.TAtt3D.Cast
import HROOT.Core.TAtt3D.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.Cast
import HROOT.Core.TAttLine.Interface
import HROOT.Core.TAttFill.RawType
import HROOT.Core.TAttFill.Cast
import HROOT.Core.TAttFill.Interface
import HROOT.Core.TAttMarker.RawType
import HROOT.Core.TAttMarker.Cast
import HROOT.Core.TAttMarker.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface
import HROOT.Core.TArray.RawType
import HROOT.Core.TArray.Cast
import HROOT.Core.TArray.Interface

import Data.Word
import Foreign.C
import Foreign.Ptr 
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITH3F TH3F where
instance ITH3 TH3F where
  fill3 = xform3 c_th3f_fill3
  fill3w = xform4 c_th3f_fill3w
  fitSlicesZ = xform7 c_th3f_fitslicesz
  getCorrelationFactor3 = xform2 c_th3f_getcorrelationfactor3
  getCovariance3 = xform2 c_th3f_getcovariance3
  rebinX3 = xform2 c_th3f_rebinx3
  rebinY3 = xform2 c_th3f_rebiny3
  rebinZ3 = xform2 c_th3f_rebinz3
  rebin3D = xform4 c_th3f_rebin3d
instance ITArrayF TH3F where
instance ITH1 TH3F where
  add = xform2 c_th3f_add
  addBinContent = xform2 c_th3f_addbincontent
  chi2Test = xform3 c_th3f_chi2test
  computeIntegral = xform0 c_th3f_computeintegral
  directoryAutoAdd = xform1 c_th3f_directoryautoadd
  divide = xform5 c_th3f_divide
  drawCopyTH1 = xform1 c_th3f_drawcopyth1
  drawNormalized = xform2 c_th3f_drawnormalized
  drawPanelTH1 = xform0 c_th3f_drawpanelth1
  bufferEmpty = xform1 c_th3f_bufferempty
  evalF = xform2 c_th3f_evalf
  fFT = xform2 c_th3f_fft
  fill1 = xform1 c_th3f_fill1
  fill1w = xform2 c_th3f_fill1w
  fillN1 = xform4 c_th3f_filln1
  fillRandom = xform2 c_th3f_fillrandom
  findBin = xform3 c_th3f_findbin
  findFixBin = xform3 c_th3f_findfixbin
  findFirstBinAbove = xform2 c_th3f_findfirstbinabove
  findLastBinAbove = xform2 c_th3f_findlastbinabove
  fitPanelTH1 = xform0 c_th3f_fitpanelth1
  getNdivisionA = xform1 c_th3f_getndivisiona
  getAxisColorA = xform1 c_th3f_getaxiscolora
  getLabelColorA = xform1 c_th3f_getlabelcolora
  getLabelFontA = xform1 c_th3f_getlabelfonta
  getLabelOffsetA = xform1 c_th3f_getlabeloffseta
  getLabelSizeA = xform1 c_th3f_getlabelsizea
  getTitleFontA = xform1 c_th3f_gettitlefonta
  getTitleOffsetA = xform1 c_th3f_gettitleoffseta
  getTitleSizeA = xform1 c_th3f_gettitlesizea
  getTickLengthA = xform1 c_th3f_getticklengtha
  getBarOffset = xform0 c_th3f_getbaroffset
  getBarWidth = xform0 c_th3f_getbarwidth
  getContour = xform1 c_th3f_getcontour
  getContourLevel = xform1 c_th3f_getcontourlevel
  getContourLevelPad = xform1 c_th3f_getcontourlevelpad
  getBin = xform3 c_th3f_getbin
  getBinCenter = xform1 c_th3f_getbincenter
  getBinContent1 = xform1 c_th3f_getbincontent1
  getBinContent2 = xform2 c_th3f_getbincontent2
  getBinContent3 = xform3 c_th3f_getbincontent3
  getBinError1 = xform1 c_th3f_getbinerror1
  getBinError2 = xform2 c_th3f_getbinerror2
  getBinError3 = xform3 c_th3f_getbinerror3
  getBinLowEdge = xform1 c_th3f_getbinlowedge
  getBinWidth = xform1 c_th3f_getbinwidth
  getCellContent = xform2 c_th3f_getcellcontent
  getCellError = xform2 c_th3f_getcellerror
  getEntries = xform0 c_th3f_getentries
  getEffectiveEntries = xform0 c_th3f_geteffectiveentries
  getFunction = xform1 c_th3f_getfunction
  getDimension = xform0 c_th3f_getdimension
  getKurtosis = xform1 c_th3f_getkurtosis
  getLowEdge = xform1 c_th3f_getlowedge
  getMaximumTH1 = xform1 c_th3f_getmaximumth1
  getMaximumBin = xform0 c_th3f_getmaximumbin
  getMaximumStored = xform0 c_th3f_getmaximumstored
  getMinimumTH1 = xform1 c_th3f_getminimumth1
  getMinimumBin = xform0 c_th3f_getminimumbin
  getMinimumStored = xform0 c_th3f_getminimumstored
  getMean = xform1 c_th3f_getmean
  getMeanError = xform1 c_th3f_getmeanerror
  getNbinsX = xform0 c_th3f_getnbinsx
  getNbinsY = xform0 c_th3f_getnbinsy
  getNbinsZ = xform0 c_th3f_getnbinsz
  getQuantilesTH1 = xform3 c_th3f_getquantilesth1
  getRandom = xform0 c_th3f_getrandom
  getStats = xform1 c_th3f_getstats
  getSumOfWeights = xform0 c_th3f_getsumofweights
  getSumw2 = xform0 c_th3f_getsumw2
  getSumw2N = xform0 c_th3f_getsumw2n
  getRMS = xform1 c_th3f_getrms
  getRMSError = xform1 c_th3f_getrmserror
  getSkewness = xform1 c_th3f_getskewness
  integral1 = xform3 c_th3f_integral1
  interpolate1 = xform1 c_th3f_interpolate1
  interpolate2 = xform2 c_th3f_interpolate2
  interpolate3 = xform3 c_th3f_interpolate3
  kolmogorovTest = xform2 c_th3f_kolmogorovtest
  labelsDeflate = xform1 c_th3f_labelsdeflate
  labelsInflate = xform1 c_th3f_labelsinflate
  labelsOption = xform2 c_th3f_labelsoption
  multiflyF = xform2 c_th3f_multiflyf
  multiply = xform5 c_th3f_multiply
  putStats = xform1 c_th3f_putstats
  rebin = xform3 c_th3f_rebin
  rebinAxis = xform2 c_th3f_rebinaxis
  rebuild = xform1 c_th3f_rebuild
  recursiveRemove = xform1 c_th3f_recursiveremove
  reset = xform1 c_th3f_reset
  resetStats = xform0 c_th3f_resetstats
  scale = xform2 c_th3f_scale
  setAxisColorA = xform2 c_th3f_setaxiscolora
  setAxisRange = xform3 c_th3f_setaxisrange
  setBarOffset = xform1 c_th3f_setbaroffset
  setBarWidth = xform1 c_th3f_setbarwidth
  setBinContent1 = xform2 c_th3f_setbincontent1
  setBinContent2 = xform3 c_th3f_setbincontent2
  setBinContent3 = xform4 c_th3f_setbincontent3
  setBinError1 = xform2 c_th3f_setbinerror1
  setBinError2 = xform3 c_th3f_setbinerror2
  setBinError3 = xform4 c_th3f_setbinerror3
  setBins1 = xform2 c_th3f_setbins1
  setBins2 = xform4 c_th3f_setbins2
  setBins3 = xform6 c_th3f_setbins3
  setBinsLength = xform1 c_th3f_setbinslength
  setBuffer = xform2 c_th3f_setbuffer
  setCellContent = xform3 c_th3f_setcellcontent
  setContent = xform1 c_th3f_setcontent
  setContour = xform2 c_th3f_setcontour
  setContourLevel = xform2 c_th3f_setcontourlevel
  setDirectory = xform1 c_th3f_setdirectory
  setEntries = xform1 c_th3f_setentries
  setError = xform1 c_th3f_seterror
  setLabelColorA = xform2 c_th3f_setlabelcolora
  setLabelSizeA = xform2 c_th3f_setlabelsizea
  setLabelFontA = xform2 c_th3f_setlabelfonta
  setLabelOffsetA = xform2 c_th3f_setlabeloffseta
  setMaximum = xform1 c_th3f_setmaximum
  setMinimum = xform1 c_th3f_setminimum
  setNormFactor = xform1 c_th3f_setnormfactor
  setStats = xform1 c_th3f_setstats
  setOption = xform1 c_th3f_setoption
  setXTitle = xform1 c_th3f_setxtitle
  setYTitle = xform1 c_th3f_setytitle
  setZTitle = xform1 c_th3f_setztitle
  showBackground = xform2 c_th3f_showbackground
  showPeaks = xform3 c_th3f_showpeaks
  smooth = xform2 c_th3f_smooth
  sumw2 = xform0 c_th3f_sumw2
instance ITAtt3D TH3F where
instance ITObject TH3F where
  draw = xform1 c_th3f_draw
  findObject = xform1 c_th3f_findobject
  getName = xform0 c_th3f_getname
  isA = xform0 c_th3f_isa
  paint = xform1 c_th3f_paint
  printObj = xform1 c_th3f_printobj
  saveAs = xform2 c_th3f_saveas
  write = xform3 c_th3f_write
instance ITAttLine TH3F where
  getLineColor = xform0 c_th3f_getlinecolor
  getLineStyle = xform0 c_th3f_getlinestyle
  getLineWidth = xform0 c_th3f_getlinewidth
  resetAttLine = xform1 c_th3f_resetattline
  setLineAttributes = xform0 c_th3f_setlineattributes
  setLineColor = xform1 c_th3f_setlinecolor
  setLineStyle = xform1 c_th3f_setlinestyle
  setLineWidth = xform1 c_th3f_setlinewidth
instance ITAttFill TH3F where
  setFillColor = xform1 c_th3f_setfillcolor
  setFillStyle = xform1 c_th3f_setfillstyle
instance ITAttMarker TH3F where
  getMarkerColor = xform0 c_th3f_getmarkercolor
  getMarkerStyle = xform0 c_th3f_getmarkerstyle
  getMarkerSize = xform0 c_th3f_getmarkersize
  resetAttMarker = xform1 c_th3f_resetattmarker
  setMarkerAttributes = xform0 c_th3f_setmarkerattributes
  setMarkerColor = xform1 c_th3f_setmarkercolor
  setMarkerStyle = xform1 c_th3f_setmarkerstyle
  setMarkerSize = xform1 c_th3f_setmarkersize
instance IDeletable TH3F where
  delete = xform0 c_th3f_delete
instance ITArray TH3F where

instance ITH3F (Exist TH3F) where

instance ITH3 (Exist TH3F) where
  fill3 (ETH3F x) = fill3 x
  fill3w (ETH3F x) = fill3w x
  fitSlicesZ (ETH3F x) = fitSlicesZ x
  getCorrelationFactor3 (ETH3F x) = getCorrelationFactor3 x
  getCovariance3 (ETH3F x) = getCovariance3 x
  rebinX3 (ETH3F x) = rebinX3 x
  rebinY3 (ETH3F x) = rebinY3 x
  rebinZ3 (ETH3F x) = rebinZ3 x
  rebin3D (ETH3F x) = rebin3D x
instance ITArrayF (Exist TH3F) where

instance ITH1 (Exist TH3F) where
  add (ETH3F x) = add x
  addBinContent (ETH3F x) = addBinContent x
  chi2Test (ETH3F x) = chi2Test x
  computeIntegral (ETH3F x) = computeIntegral x
  directoryAutoAdd (ETH3F x) = directoryAutoAdd x
  divide (ETH3F x) = divide x
  drawCopyTH1 (ETH3F x) a1 = return . ETH3F =<< drawCopyTH1 x a1
  drawNormalized (ETH3F x) = drawNormalized x
  drawPanelTH1 (ETH3F x) = drawPanelTH1 x
  bufferEmpty (ETH3F x) = bufferEmpty x
  evalF (ETH3F x) = evalF x
  fFT (ETH3F x) = fFT x
  fill1 (ETH3F x) = fill1 x
  fill1w (ETH3F x) = fill1w x
  fillN1 (ETH3F x) = fillN1 x
  fillRandom (ETH3F x) = fillRandom x
  findBin (ETH3F x) = findBin x
  findFixBin (ETH3F x) = findFixBin x
  findFirstBinAbove (ETH3F x) = findFirstBinAbove x
  findLastBinAbove (ETH3F x) = findLastBinAbove x
  fitPanelTH1 (ETH3F x) = fitPanelTH1 x
  getNdivisionA (ETH3F x) = getNdivisionA x
  getAxisColorA (ETH3F x) = getAxisColorA x
  getLabelColorA (ETH3F x) = getLabelColorA x
  getLabelFontA (ETH3F x) = getLabelFontA x
  getLabelOffsetA (ETH3F x) = getLabelOffsetA x
  getLabelSizeA (ETH3F x) = getLabelSizeA x
  getTitleFontA (ETH3F x) = getTitleFontA x
  getTitleOffsetA (ETH3F x) = getTitleOffsetA x
  getTitleSizeA (ETH3F x) = getTitleSizeA x
  getTickLengthA (ETH3F x) = getTickLengthA x
  getBarOffset (ETH3F x) = getBarOffset x
  getBarWidth (ETH3F x) = getBarWidth x
  getContour (ETH3F x) = getContour x
  getContourLevel (ETH3F x) = getContourLevel x
  getContourLevelPad (ETH3F x) = getContourLevelPad x
  getBin (ETH3F x) = getBin x
  getBinCenter (ETH3F x) = getBinCenter x
  getBinContent1 (ETH3F x) = getBinContent1 x
  getBinContent2 (ETH3F x) = getBinContent2 x
  getBinContent3 (ETH3F x) = getBinContent3 x
  getBinError1 (ETH3F x) = getBinError1 x
  getBinError2 (ETH3F x) = getBinError2 x
  getBinError3 (ETH3F x) = getBinError3 x
  getBinLowEdge (ETH3F x) = getBinLowEdge x
  getBinWidth (ETH3F x) = getBinWidth x
  getCellContent (ETH3F x) = getCellContent x
  getCellError (ETH3F x) = getCellError x
  getEntries (ETH3F x) = getEntries x
  getEffectiveEntries (ETH3F x) = getEffectiveEntries x
  getFunction (ETH3F x) = getFunction x
  getDimension (ETH3F x) = getDimension x
  getKurtosis (ETH3F x) = getKurtosis x
  getLowEdge (ETH3F x) = getLowEdge x
  getMaximumTH1 (ETH3F x) = getMaximumTH1 x
  getMaximumBin (ETH3F x) = getMaximumBin x
  getMaximumStored (ETH3F x) = getMaximumStored x
  getMinimumTH1 (ETH3F x) = getMinimumTH1 x
  getMinimumBin (ETH3F x) = getMinimumBin x
  getMinimumStored (ETH3F x) = getMinimumStored x
  getMean (ETH3F x) = getMean x
  getMeanError (ETH3F x) = getMeanError x
  getNbinsX (ETH3F x) = getNbinsX x
  getNbinsY (ETH3F x) = getNbinsY x
  getNbinsZ (ETH3F x) = getNbinsZ x
  getQuantilesTH1 (ETH3F x) = getQuantilesTH1 x
  getRandom (ETH3F x) = getRandom x
  getStats (ETH3F x) = getStats x
  getSumOfWeights (ETH3F x) = getSumOfWeights x
  getSumw2 (ETH3F x) = getSumw2 x
  getSumw2N (ETH3F x) = getSumw2N x
  getRMS (ETH3F x) = getRMS x
  getRMSError (ETH3F x) = getRMSError x
  getSkewness (ETH3F x) = getSkewness x
  integral1 (ETH3F x) = integral1 x
  interpolate1 (ETH3F x) = interpolate1 x
  interpolate2 (ETH3F x) = interpolate2 x
  interpolate3 (ETH3F x) = interpolate3 x
  kolmogorovTest (ETH3F x) = kolmogorovTest x
  labelsDeflate (ETH3F x) = labelsDeflate x
  labelsInflate (ETH3F x) = labelsInflate x
  labelsOption (ETH3F x) = labelsOption x
  multiflyF (ETH3F x) = multiflyF x
  multiply (ETH3F x) = multiply x
  putStats (ETH3F x) = putStats x
  rebin (ETH3F x) = rebin x
  rebinAxis (ETH3F x) = rebinAxis x
  rebuild (ETH3F x) = rebuild x
  recursiveRemove (ETH3F x) = recursiveRemove x
  reset (ETH3F x) = reset x
  resetStats (ETH3F x) = resetStats x
  scale (ETH3F x) = scale x
  setAxisColorA (ETH3F x) = setAxisColorA x
  setAxisRange (ETH3F x) = setAxisRange x
  setBarOffset (ETH3F x) = setBarOffset x
  setBarWidth (ETH3F x) = setBarWidth x
  setBinContent1 (ETH3F x) = setBinContent1 x
  setBinContent2 (ETH3F x) = setBinContent2 x
  setBinContent3 (ETH3F x) = setBinContent3 x
  setBinError1 (ETH3F x) = setBinError1 x
  setBinError2 (ETH3F x) = setBinError2 x
  setBinError3 (ETH3F x) = setBinError3 x
  setBins1 (ETH3F x) = setBins1 x
  setBins2 (ETH3F x) = setBins2 x
  setBins3 (ETH3F x) = setBins3 x
  setBinsLength (ETH3F x) = setBinsLength x
  setBuffer (ETH3F x) = setBuffer x
  setCellContent (ETH3F x) = setCellContent x
  setContent (ETH3F x) = setContent x
  setContour (ETH3F x) = setContour x
  setContourLevel (ETH3F x) = setContourLevel x
  setDirectory (ETH3F x) = setDirectory x
  setEntries (ETH3F x) = setEntries x
  setError (ETH3F x) = setError x
  setLabelColorA (ETH3F x) = setLabelColorA x
  setLabelSizeA (ETH3F x) = setLabelSizeA x
  setLabelFontA (ETH3F x) = setLabelFontA x
  setLabelOffsetA (ETH3F x) = setLabelOffsetA x
  setMaximum (ETH3F x) = setMaximum x
  setMinimum (ETH3F x) = setMinimum x
  setNormFactor (ETH3F x) = setNormFactor x
  setStats (ETH3F x) = setStats x
  setOption (ETH3F x) = setOption x
  setXTitle (ETH3F x) = setXTitle x
  setYTitle (ETH3F x) = setYTitle x
  setZTitle (ETH3F x) = setZTitle x
  showBackground (ETH3F x) = showBackground x
  showPeaks (ETH3F x) = showPeaks x
  smooth (ETH3F x) = smooth x
  sumw2 (ETH3F x) = sumw2 x
instance ITAtt3D (Exist TH3F) where

instance ITObject (Exist TH3F) where
  draw (ETH3F x) = draw x
  findObject (ETH3F x) = findObject x
  getName (ETH3F x) = getName x
  isA (ETH3F x) = isA x
  paint (ETH3F x) = paint x
  printObj (ETH3F x) = printObj x
  saveAs (ETH3F x) = saveAs x
  write (ETH3F x) = write x
instance ITAttLine (Exist TH3F) where
  getLineColor (ETH3F x) = getLineColor x
  getLineStyle (ETH3F x) = getLineStyle x
  getLineWidth (ETH3F x) = getLineWidth x
  resetAttLine (ETH3F x) = resetAttLine x
  setLineAttributes (ETH3F x) = setLineAttributes x
  setLineColor (ETH3F x) = setLineColor x
  setLineStyle (ETH3F x) = setLineStyle x
  setLineWidth (ETH3F x) = setLineWidth x
instance ITAttFill (Exist TH3F) where
  setFillColor (ETH3F x) = setFillColor x
  setFillStyle (ETH3F x) = setFillStyle x
instance ITAttMarker (Exist TH3F) where
  getMarkerColor (ETH3F x) = getMarkerColor x
  getMarkerStyle (ETH3F x) = getMarkerStyle x
  getMarkerSize (ETH3F x) = getMarkerSize x
  resetAttMarker (ETH3F x) = resetAttMarker x
  setMarkerAttributes (ETH3F x) = setMarkerAttributes x
  setMarkerColor (ETH3F x) = setMarkerColor x
  setMarkerStyle (ETH3F x) = setMarkerStyle x
  setMarkerSize (ETH3F x) = setMarkerSize x
instance IDeletable (Exist TH3F) where
  delete (ETH3F x) = delete x
instance ITArray (Exist TH3F) where








instance FPtr (Exist TH3F) where
  type Raw (Exist TH3F) = RawTH3F
  get_fptr (ETH3F obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETH3F (cast_fptr_to_obj (fptr :: ForeignPtr RawTH3F) :: TH3F)
